using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Ink;
using RecognizeSignature.DataBase;
using RecognizeSignature;

namespace RecognizeSignature
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormSign : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		ArrayList theTimeTick = new ArrayList();
		ArrayList signatureData = new ArrayList();
		private System.Windows.Forms.Button btnRecognize;
		private System.Windows.Forms.Button btnClose;
		InkCollector myInkCollector;
		private System.Windows.Forms.Label lSignature;
		private System.Windows.Forms.Panel panelInk;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuRecognize;
		private System.Windows.Forms.MenuItem menuInputData;
		private System.Windows.Forms.TextBox tbFName;
		private System.Windows.Forms.TextBox tbSName;
		private System.Windows.Forms.TextBox tbLName;
		int mode = 0;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		int PersonId = 0;

		public FormSign()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//



			// window handle, then enable it.
//			Tablets tbs = new Tablets();
//			Tablet tablet = null;
//			
//			foreach( Tablet tb in tbs)
//			{
//				if( tbs.IsPacketPropertySupported(PacketProperty.NormalPressure) )
//				{
//					tablet = tb;
//				}
//			}

			myInkCollector = new InkCollector(panelInk.Handle);//,tablet);
			//myInkCollector.SetSingleTabletIntegratedMode(tablet);
			myInkCollector.Enabled = true;
			mode = 0;
			Guid [] guid = new Guid[4];
			guid[0] = PacketProperty.X;
			guid[1] = PacketProperty.Y;
			guid[2] = PacketProperty.NormalPressure;
			guid[3] = PacketProperty.TimerTick;
		//	myInkCollector.DesiredPacketDescription = guid;
//			bool res = this.AreTabletComponentsInstalled();
//				
//			if(res == false)
//				MessageBox.Show("Tablet Device Not Installed");

			

			//myInkCollector.DefaultDrawingAttributes.IgnorePressure = false;
			// Add a handler for Stroke Events so we can record
			// an extended property with each one.
			myInkCollector.Stroke += new InkCollectorStrokeEventHandler(MyStrokeHandler);
			myInkCollector.NewPackets += new InkCollectorNewPacketsEventHandler(MyPacketHandler);
			myInkCollector.TabletAdded += new InkCollectorTabletAddedEventHandler(TabletAdded_Event);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnRecognize = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.lSignature = new System.Windows.Forms.Label();
			this.panelInk = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tbFName = new System.Windows.Forms.TextBox();
			this.tbSName = new System.Windows.Forms.TextBox();
			this.tbLName = new System.Windows.Forms.TextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuRecognize = new System.Windows.Forms.MenuItem();
			this.menuInputData = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// btnRecognize
			// 
			this.btnRecognize.Location = new System.Drawing.Point(216, 208);
			this.btnRecognize.Name = "btnRecognize";
			this.btnRecognize.TabIndex = 0;
			this.btnRecognize.Text = "&Recognize";
			this.btnRecognize.Click += new System.EventHandler(this.btnRecognize_Click);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(312, 208);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 1;
			this.btnClose.Text = "&Clear";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// lSignature
			// 
			this.lSignature.Location = new System.Drawing.Point(216, 24);
			this.lSignature.Name = "lSignature";
			this.lSignature.Size = new System.Drawing.Size(100, 16);
			this.lSignature.TabIndex = 2;
			this.lSignature.Text = "Signature ";
			// 
			// panelInk
			// 
			this.panelInk.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.panelInk.Location = new System.Drawing.Point(216, 48);
			this.panelInk.Name = "panelInk";
			this.panelInk.Size = new System.Drawing.Size(288, 128);
			this.panelInk.TabIndex = 3;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "First Name";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Second Name";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(64, 23);
			this.label3.TabIndex = 6;
			this.label3.Text = "Last Name";
			// 
			// tbFName
			// 
			this.tbFName.Location = new System.Drawing.Point(96, 56);
			this.tbFName.Name = "tbFName";
			this.tbFName.Size = new System.Drawing.Size(104, 20);
			this.tbFName.TabIndex = 8;
			this.tbFName.Text = "";
			// 
			// tbSName
			// 
			this.tbSName.Location = new System.Drawing.Point(96, 104);
			this.tbSName.Name = "tbSName";
			this.tbSName.Size = new System.Drawing.Size(104, 20);
			this.tbSName.TabIndex = 9;
			this.tbSName.Text = "";
			// 
			// tbLName
			// 
			this.tbLName.Location = new System.Drawing.Point(96, 152);
			this.tbLName.Name = "tbLName";
			this.tbLName.Size = new System.Drawing.Size(104, 20);
			this.tbLName.TabIndex = 10;
			this.tbLName.Text = "";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem2,
																					  this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuRecognize,
																					  this.menuInputData});
			this.menuItem1.Text = "Mode";
			// 
			// menuRecognize
			// 
			this.menuRecognize.Checked = true;
			this.menuRecognize.Index = 0;
			this.menuRecognize.Text = "Recognize";
			this.menuRecognize.Click += new System.EventHandler(this.menuRecognize_Click);
			// 
			// menuInputData
			// 
			this.menuInputData.Index = 1;
			this.menuInputData.Text = "Collection of Signature";
			this.menuInputData.Click += new System.EventHandler(this.menuInputData_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem5});
			this.menuItem2.Text = "Method";
			// 
			// menuItem4
			// 
			this.menuItem4.Checked = true;
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "Evklid Distance";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuHelp});
			this.menuItem3.Text = "About";
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 0;
			this.menuHelp.Text = "Help";
			this.menuHelp.Click += new System.EventHandler(this.menuHelp_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "Mahalanobis Distance";
			// 
			// FormSign
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 257);
			this.Controls.Add(this.tbLName);
			this.Controls.Add(this.tbSName);
			this.Controls.Add(this.tbFName);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.panelInk);
			this.Controls.Add(this.lSignature);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.btnRecognize);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Name = "FormSign";
			this.Text = "Recognize Signature";
			this.Load += new System.EventHandler(this.FormSign_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormSign());
		}

		private void FormSign_Load(object sender, System.EventArgs e)
		{
		
		}

		public void MyStrokeHandler(object sender, InkCollectorStrokeEventArgs e)
		{
			// Write the current time into this stroke.
			// First get the time as a long.
			long theTime = DateTime.Now.ToFileTime();
			// Store the data under the Guid key.
			//e.Stroke.ExtendedProperties.Add(myTimeGuid, theTime);
		}
        
		public void MyPacketHandler(object sender, InkCollectorNewPacketsEventArgs e)
		{
			// Write the current time into this stroke.
			// First get the time as a long.
			long theTime = DateTime.Now.ToFileTime();
			// e.Stroke.ExtendedProperties.Add(myTimeGuid, theTime);
			// e.Cursor.DrawingAttributes..SetPacketValuesByProperty(PacketProperty.TimerTick, theTime);
			//bool isfixed = e.PacketData.IsFixedSize;
			//int index = e.PacketData.Length;
			// Store the data under the Guid key.
			//object data = e.PacketData.SyncRoot;
			//e.PacketData.SetValue(theTime, 1);
			theTimeTick.Add(theTime);
		}

		private void TabletAdded_Event(object sender, InkCollectorTabletAddedEventArgs e)
		{
			MessageBox.Show(ReportTablet(e.Tablet));
		}

		//TODO this is not working for me?
		private bool AreTabletComponentsInstalled()
		{
//			object o = Activator.CreateInstanceFrom("Microsoft.Ink", "Microsoft.Ink.InkCollector");
//			object o = Activator.CreateInstance("Microsoft.Ink", "Microsoft.Ink.InkCollector");
			Type t = Type.GetType("Microsoft.Ink.InkCollector");
			if(t == null)
				return false;
			object o = Activator.CreateInstance(t);
			if(o == null)
				return false;
			else
				return true;
		}


		public string ReportOnEachTablet()
		{
			Tablets theTablets = new Tablets();
			string theReport = "\r\n";

			// Iterate over the tablets in the collection, reporting on each one.
			foreach (Tablet theTablet in theTablets)
			{
				theReport += "Tablet Name: " + theTablet.Name + "\r\n";
				if (theTablets.DefaultTablet.Name.Equals(theTablet.Name))
					theReport += "(Default)\r\n";
				theReport += "PlugAndPlayId: " + theTablet.PlugAndPlayId + "\r\n";
				theReport += "HardwareCapabilities: " + theTablet.HardwareCapabilities.ToString() + "\r\n";
				if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.CursorMustTouch) != 0)
					theReport += "    CursorMustTouch\r\n";
				if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.CursorsHavePhysicalIds) != 0)
					theReport += "    CursorsHavePhysicalIds\r\n";
				if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.HardProximity) != 0)
					theReport += "    HardProximity\r\n";
				if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.Integrated) != 0)
					theReport += "    Integrated\r\n";
				theReport += "MaximumInputRectangle " + theTablet.MaximumInputRectangle.ToString() + "\r\n";

				//Report on each supported Packet Property.
				theReport += "IsPacketPropertySupported:\r\n";
				theReport += GetProperty(theTablet, PacketProperty.AltitudeOrientation, "AltitudeOrientation");
				theReport += GetProperty(theTablet, PacketProperty.AzimuthOrientation, "AzimuthOrientation");
				theReport += GetProperty(theTablet, PacketProperty.ButtonPressure, "ButtonPressure");
				theReport += GetProperty(theTablet, PacketProperty.NormalPressure, "NormalPressure");
				theReport += GetProperty(theTablet, PacketProperty.PacketStatus, "PacketStatus");
				theReport += GetProperty(theTablet, PacketProperty.PitchRotation, "PitchRotation");
				theReport += GetProperty(theTablet, PacketProperty.RollRotation, "RollRotation");
				theReport += GetProperty(theTablet, PacketProperty.SerialNumber, "SerialNumber");
				theReport += GetProperty(theTablet, PacketProperty.TangentPressure, "TangentPressure");
				theReport += GetProperty(theTablet, PacketProperty.TimerTick, "TimerTick");
				theReport += GetProperty(theTablet, PacketProperty.TwistOrientation, "TwistOrientation");
				theReport += GetProperty(theTablet, PacketProperty.X, "X");
				theReport += GetProperty(theTablet, PacketProperty.XTiltOrientation, "XTiltOrientation");
				theReport += GetProperty(theTablet, PacketProperty.Y, "Y");
				theReport += GetProperty(theTablet, PacketProperty.YawRotation, "YawRotation");
				theReport += GetProperty(theTablet, PacketProperty.YTiltOrientation, "YTiltOrientation");
				theReport += GetProperty(theTablet, PacketProperty.Z, "Z");
				theReport += "\r\n";
			}
			return theReport;
		}


		public string ReportTablet(Tablet theTablet)
		{
			
			string theReport = "\r\n";

			// Iterate over the tablets in the collection, reporting on each one.
			
			theReport += "Tablet Name: " + theTablet.Name + "\r\n";
			//				if (theTablet.DefaultTablet.Name.Equals(theTablet.Name))
			//					theReport += "(Default)\r\n";
			theReport += "PlugAndPlayId: " + theTablet.PlugAndPlayId + "\r\n";
			theReport += "HardwareCapabilities: " + theTablet.HardwareCapabilities.ToString() + "\r\n";
			if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.CursorMustTouch) != 0)
				theReport += "    CursorMustTouch\r\n";
			if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.CursorsHavePhysicalIds) != 0)
				theReport += "    CursorsHavePhysicalIds\r\n";
			if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.HardProximity) != 0)
				theReport += "    HardProximity\r\n";
			if ((theTablet.HardwareCapabilities & TabletHardwareCapabilities.Integrated) != 0)
				theReport += "    Integrated\r\n";
			theReport += "MaximumInputRectangle " + theTablet.MaximumInputRectangle.ToString() + "\r\n";

			//Report on each supported Packet Property.
			theReport += "IsPacketPropertySupported:\r\n";
			theReport += GetProperty(theTablet, PacketProperty.AltitudeOrientation, "AltitudeOrientation");
			theReport += GetProperty(theTablet, PacketProperty.AzimuthOrientation, "AzimuthOrientation");
			theReport += GetProperty(theTablet, PacketProperty.ButtonPressure, "ButtonPressure");
			theReport += GetProperty(theTablet, PacketProperty.NormalPressure, "NormalPressure");
			theReport += GetProperty(theTablet, PacketProperty.PacketStatus, "PacketStatus");
			theReport += GetProperty(theTablet, PacketProperty.PitchRotation, "PitchRotation");
			theReport += GetProperty(theTablet, PacketProperty.RollRotation, "RollRotation");
			theReport += GetProperty(theTablet, PacketProperty.SerialNumber, "SerialNumber");
			theReport += GetProperty(theTablet, PacketProperty.TangentPressure, "TangentPressure");
			theReport += GetProperty(theTablet, PacketProperty.TimerTick, "TimerTick");
			theReport += GetProperty(theTablet, PacketProperty.TwistOrientation, "TwistOrientation");
			theReport += GetProperty(theTablet, PacketProperty.X, "X");
			theReport += GetProperty(theTablet, PacketProperty.XTiltOrientation, "XTiltOrientation");
			theReport += GetProperty(theTablet, PacketProperty.Y, "Y");
			theReport += GetProperty(theTablet, PacketProperty.YawRotation, "YawRotation");
			theReport += GetProperty(theTablet, PacketProperty.YTiltOrientation, "YTiltOrientation");
			theReport += GetProperty(theTablet, PacketProperty.Z, "Z");
			theReport += "\r\n";
			
			return theReport;
		}

		public string GetProperty(Tablet theTablet, Guid theGuid, string name)
		{
			string theReport = "";
			// If this particular property is supported,
			// report the name and property metrics information.
			if (theTablet.IsPacketPropertySupported(theGuid))
			{
				TabletPropertyMetrics theMetrics = theTablet.GetPropertyMetrics(theGuid);

				theReport += "    " + name + "\r\n" +
					"        Max: " + theMetrics.Maximum.ToString() + "\r\n" +
					"        Min: " + theMetrics.Minimum.ToString() + "\r\n" +
					"        Resolution: " + theMetrics.Resolution.ToString() + "\r\n" +
					"        Units: " + theMetrics.Units.ToString() + "\r\n";
			}
			return theReport;
		}

		private void btnRecognize_Click(object sender, System.EventArgs e)
		{
			if (mode == 0)
			{
				RecognizeSignature(0);
				
			}
			if (mode == 1)
			{
				SaveSignature();
			}
            
			
		}

		private void SaveSignature()
		{

			//calculate sign properties
			SignProperties signature = new SignProperties(myInkCollector);

			Point center = signature.properties.GetGeometCenter();
			Point center1 = signature.properties.GetWeightCenter();
			double distance = signature.properties.GetDistanceCenters();
			double angle = signature.properties.GetAngle_GC_WC();
			double dispersiaX = signature.properties.GetDispersia("X");
			double dispersiaY = signature.properties.GetDispersia("Y");
			double dispersiaPressure = signature.properties.GetDispersia("P");

			int    numberStrokes = signature.properties.NumberStrokes;
			int    numberPixels =  signature.properties.NumberPixels;
			int    width        =  signature.properties.Width;
			double length       =  signature.properties.Length;
			double complexity   =  signature.properties.Complexity;
			int    kind         = 0;  // 0- data; 1-etalon;

			

			//add Person data
			Person pr = new Person();
			if (signatureData.Count == 0)
			{
				string f_name =tbFName.Text;
				string s_name = tbSName.Text;
				string l_name = tbLName.Text;
				pr = new Person("7804034649", f_name, s_name, l_name);
				if(f_name == "" || s_name == "" || l_name == "")
				{
				  MessageBox.Show("Please insert F_name or S_name or L_name!");
				  return;
				}
				string constraint = "F_name='" + f_name + "' and S_name='" + s_name + "' and L_name='" + l_name+"'";
				object[] objPerson = pr.Find(constraint);
				if( objPerson.Length == 0)
				{
					pr.Create();
					PersonId = pr.id;
				}
				else
				{
					PersonId = ((Person)objPerson[0]).id;
				}
					
			}
			
			string signBinary = SignProperties.SaveIncCollectorToString(myInkCollector);
			Signature sign = new Signature(distance, angle, dispersiaX, dispersiaY, dispersiaPressure, signBinary, PersonId, numberStrokes,numberPixels,width,length,complexity,kind);
			signatureData.Add(sign);
			DeleteInkCollector();

			lSignature.Text = "Signature: " + (signatureData.Count+1);
            
			if (signatureData.Count == 9)
				btnRecognize.Text = "&Save";
			if (signatureData.Count == 10)
			{
				//Save data in Data Base
				for (int i = 0; i < signatureData.Count; i++)
					((Signature)signatureData[i]).Create();
				//pr.Create();
                Signature.CalculateEtalon(PersonId);
				//Clear data 
                   
				signatureData.Clear();
				btnRecognize.Text = "&Add";
				lSignature.Text = "Signature: 1";
				tbFName.Text ="";
				tbSName.Text = "";
				tbLName.Text = "";
			}
			
		//	object[] objPerson = pr.Find("Id=8");
		//	object[] objSignature = sign.Find("Id_Person=8");
		}

		private void RecognizeSignature(int method)
		{
			//calculate sign properties
			SignProperties signature = new SignProperties(myInkCollector);

			Point center = signature.properties.GetGeometCenter();
			Point center1 = signature.properties.GetWeightCenter();
			double distance = signature.properties.GetDistanceCenters();
			double angle = signature.properties.GetAngle_GC_WC();
			double dispersiaX = signature.properties.GetDispersia("X");
			double dispersiaY = signature.properties.GetDispersia("Y");
			double dispersiaPressure = signature.properties.GetDispersia("P");

			int    numberStrokes = signature.properties.NumberStrokes;
			int    numberPixels =  signature.properties.NumberPixels;
			int    width        =  signature.properties.Width;
			double length       =  signature.properties.Length;
			double complexity   =  signature.properties.Complexity;
			int    kind         = 0;  // 0- data; 1-etalon;
			Signature sign = new Signature(distance, angle, dispersiaX, dispersiaY, dispersiaPressure, "", 0,numberStrokes,numberPixels,width,length,complexity,kind);
			

			switch (method)
			{
				//Calcualte min Evklid Distance
				case 0:
					Person pr = SignRecognize.RecognizeSignaturePerson_Evklid(sign);
					tbFName.Text = pr.F_name;
					tbSName.Text = pr.S_name;
					tbLName.Text = pr.L_name;
					DeleteInkCollector();
					break;
			    case 1: break;
			    case 2: break;
			    case 3: break;
			}
		}

		private void menuHelp_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(ReportOnEachTablet());
		}

		private void menuRecognize_Click(object sender, System.EventArgs e)
		{
			if(menuRecognize.Checked == true)
			{
				mode = 0;
				menuInputData.Checked = false;
				btnRecognize.Text = "Recognize";
				lSignature.Text = "Signature";
			}
			else
			{
				mode = 0;
				menuRecognize.Checked =true;
				menuInputData.Checked = false;
				btnRecognize.Text = "Recognize";
				lSignature.Text = "Signature";
			}
		}

		private void menuInputData_Click(object sender, System.EventArgs e)
		{
			if(menuInputData.Checked == true)
			{
				mode = 1;
				menuRecognize.Checked = false;
				btnRecognize.Text = "Add";
				lSignature.Text = "Signature: 1";
				DeleteInkCollector();

			}
			else
			{
				mode = 1;
				menuInputData.Checked =true;
				menuRecognize.Checked = false;
				btnRecognize.Text = "Add";
				lSignature.Text = "Signature: 1";

				DeleteInkCollector();

			}
		}

		private void DeleteInkCollector()
		{
			myInkCollector.Dispose();
			myInkCollector = new InkCollector(panelInk.Handle);
			myInkCollector.Enabled = true;
			panelInk.Invalidate();
		}
		private void CreateInkCollector()
		{
			myInkCollector = new InkCollector(panelInk.Handle);
			myInkCollector.Enabled = true;
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
		   DeleteInkCollector();
		}

	}
}
