﻿using System;
using System.Collections;
using System.Data.SqlClient;
using System.Data;
using System.Configuration;
using System.Globalization;

namespace RecognizeSignature
{
	/// <summary>
	/// Summary description for Root.
	/// </summary>
	public class Root
	{
		protected string [] columns = {};
		protected string [] commonColumns = { "Id"};
		public int id = -1;

		protected string tableName = "";
		public static CultureInfo cl_en = new CultureInfo("en-US");
		public static CultureInfo cl_bg = new CultureInfo("bg-BG");
        public static string connectionString = @"Persist Security Info=False;User ID=meri;pwd=meri#dilian;Data Source=Dilyan\SQLEXPRESS;Packet Size=4096;Workstation ID=213.174.1.72\SQLEXPRESS; Initial Catalog=RecognizeSignature";
	    //ConfigurationSettings.AppSettings["SqlString"];
		
		public virtual string DisplayId
		{
			get { return "Oбект със служебни данни";}
		}

		public virtual string[] Columns
		{
			get
			{
				return columns;
			}

			set
			{
				columns = value;
			}
		}

		public virtual string TableName
		{
			get
			{
				return tableName;
			}

			set
			{
				tableName = value;
			}
		}

	
		/// <summary>
		/// Get member fields from instance of object
		/// </summary>
		/// <returns>Hashtabel</returns>
		public virtual Hashtable GetValues()
		{
			Hashtable hash = new Hashtable();
			hash.Add( commonColumns[0], id );
			return hash;
		}

		/// <summary>
		/// Set instance of object from HashTable
		/// </summary>
		/// <param name="hashTable"></param>
		public virtual void SetValues(Hashtable hashTable)
		{			
			if( hashTable.ContainsKey( commonColumns[0] ) )
				id = int.Parse( hashTable[ commonColumns[0] ].ToString() );
			
			
		}
		
		public object [] Find( string constraint )
		{
			SqlConnection sqlConnection = new SqlConnection( connectionString );
		
			ArrayList arrList = new ArrayList();
			try
			{
				sqlConnection.Open();
				SqlCommand command;
				if( constraint.Length == 0 )
					command = new SqlCommand("SELECT * FROM [" + TableName +"]", sqlConnection);
				else
					command = new SqlCommand("SELECT * FROM [" + TableName + "] WHERE " + constraint, sqlConnection);
	
				SqlDataReader reader = command.ExecuteReader();
				
				while( reader.Read() )
				{
					Hashtable h = new Hashtable();
					
					foreach( string s in commonColumns )
					{
						h.Add(s, reader[s]);
					}

					foreach( string s in Columns )
					{
						h.Add(s, reader[s]);
					}
								
					Root instance = CreateInstance();
					instance.SetValues(h);
					
					arrList.Add( instance );
				}

				reader.Close();
				sqlConnection.Close();
				return arrList.ToArray();
			}
			catch( Exception ex )
			{
				Console.WriteLine(ex.Message);
				Console.WriteLine(ex.StackTrace);

				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
				return arrList.ToArray();
			}
		}


		public object [] Find( string joinCondition,string constraint )
		{
			SqlConnection sqlConnection = new SqlConnection( connectionString );
		
			ArrayList arrList = new ArrayList();
			try
			{
				sqlConnection.Open();
				SqlCommand command;
				if( constraint.Length == 0 )
				
					command = new SqlCommand(	"SELECT DISTINCT [" + TableName +"].* FROM [" + TableName +"] inner join "+ joinCondition, sqlConnection);
				else
					command = new SqlCommand(	"SELECT DISTINCT [" + TableName +"].* FROM [" + TableName +"] inner join "+ joinCondition +" WHERE " + constraint, sqlConnection);
	
				SqlDataReader reader = command.ExecuteReader();
				
				while( reader.Read() )
				{
					Hashtable h = new Hashtable();
					
					foreach( string s in commonColumns )
					{
						h.Add(s, reader[s]);
					}

					foreach( string s in Columns )
					{
						h.Add(s, reader[s]);
					}
								
					Root instance = CreateInstance();
					instance.SetValues(h);
					
					arrList.Add( instance );
				}

				reader.Close();
				sqlConnection.Close();
				return arrList.ToArray();
			}
			catch( Exception ex )
			{
				Console.WriteLine(ex.Message);
				Console.WriteLine(ex.StackTrace);

				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
				return arrList.ToArray();
			}
		}


		public void Create()
		{
			SqlConnection sqlConnection = new SqlConnection( connectionString );
			try
			{
				sqlConnection.Open();
				if( id == -1 )
				{
					string cols = "";
					string values = "";
					Hashtable h = GetValues();
					foreach( object k in h.Keys )
					{
						if( k.ToString() == "Id" ) continue;
						
						cols += k + ",";

						if( h[k].GetType() == typeof(string) || h[k].GetType() == typeof(DateTime) )
						{
							if(h[k].GetType() == typeof(DateTime) )
							{
								values += "'" + ((DateTime)h[k]).ToString(cl_en) + "'" + ",";
							}
							else
							{
								values += "'" + h[k] + "'" + ",";
							}
						}
						else 
						{

                            

							if(h[k].GetType() == typeof(decimal))
								values += ((decimal)h[k]).ToString(cl_en) + ",";
							else
                                if (h[k].GetType() == typeof(double))
                                    values += ((double)h[k]).ToString(cl_en) + ",";
                                else
								values +=  h[k] + ",";
						}

					}
					cols = cols.Substring( 0, cols.Length - 1 );
					values = values.Substring(0, values.Length - 1);
					string s = "INSERT INTO [" + TableName + " ] ("+ cols + ")" + " VALUES( "+ values + ")";
					SqlCommand command = new SqlCommand(s, sqlConnection);
					command.ExecuteNonQuery();

					string constraint="";
					foreach( object k in h.Keys )
					{
						if( k.ToString() == "Id" ) continue;
						
						constraint += k + " = " ;


						if( h[k].GetType() == typeof(string) || h[k].GetType() == typeof(DateTime) )
						{
							if(h[k].GetType() == typeof(DateTime) )
							{
								constraint += "'" + ((DateTime)h[k]).ToString(cl_en) + "'" + " and ";
							}
							else
							{
								constraint += "'" + h[k] + "'" + " and ";
							}
							
						}
						else 
						{
							if(h[k].GetType() == typeof(decimal))
								constraint += ((decimal)h[k]).ToString(cl_en) + " and ";
							else 
								if (h[k].GetType() == typeof(double))
								constraint += ((double)h[k]).ToString(cl_en) + " and ";
							else
								constraint +=  h[k] + " and ";
						}

					}
					constraint = constraint.Substring(0,constraint.Length -5);
					string s1 = "SELECT Id FROM [" + TableName + "] WHERE " + constraint; 
					command = new SqlCommand(s1, sqlConnection);
					SqlDataReader reader = command.ExecuteReader();
					reader.Read();
					id= int.Parse(reader["Id"].ToString());
				}
				sqlConnection.Close();
			}
			catch( Exception ex )
			{
				Console.WriteLine(ex.Message);
				Console.WriteLine(ex.StackTrace);
				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
			}
		}

		public void Update()
		{
			SqlConnection sqlConnection = new SqlConnection( connectionString );
			try
			{
				sqlConnection.Open();
				string updateString ="";
				Hashtable h = GetValues();
				foreach( object k in h.Keys )
				{
					if( k.ToString() == "Id" ) continue;
						
					updateString += k + "= ";
					if( h[k].GetType() == typeof(string) || h[k].GetType() == typeof(DateTime) )
					{
						updateString += "'" + h[k] + "'" + ",";
					}
					else
					{
						if(h[k].GetType() == typeof(decimal))
							updateString += ((decimal)h[k]).ToString(cl_en) + ",";
						
							else
                                if (h[k].GetType() == typeof(double))
                                    updateString += ((double)h[k]).ToString(cl_en) + ",";
                                else
								updateString +=  h[k] + ",";
					}
				}
				updateString = updateString.Substring( 0, updateString.Length - 1 );
				//			string s = "UPDATE [" + TableName +"] SET "+ commonColumns[2] + "='" + DateTime.Now + "' WHERE " + commonColumns[0] + "=" + id;
				string s = "UPDATE [" + TableName +"] SET " + updateString + " WHERE " + commonColumns[0] + "=" + id;
				SqlCommand command = new SqlCommand(s, sqlConnection);
				command.ExecuteNonQuery();
				sqlConnection.Close();
			}
			catch( Exception e )
			{
				Console.WriteLine(e.Message);
				Console.WriteLine(e.StackTrace);
				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
			}
		}

		public bool Delete( string constraint )
		{
			
			SqlConnection sqlConnection = new SqlConnection( connectionString );
			try
			{
				sqlConnection.Open();
				string s = "DELETE FROM [" + TableName +"] WHERE "+ constraint;
				SqlCommand command = new SqlCommand(s, sqlConnection);
				command.ExecuteNonQuery();
			
				sqlConnection.Close();
				return true;
			}
			catch( Exception e )
			{
				Console.WriteLine(e.Message);
				Console.WriteLine(e.StackTrace);
				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
				return false;
			}
		}

		public static bool ExecuteCommand(string myCommand)
		{
			SqlConnection sqlConnection = new SqlConnection( connectionString );
			try
			{
				sqlConnection.Open();
				SqlCommand command = new SqlCommand(myCommand, sqlConnection);
				command.ExecuteNonQuery();
				sqlConnection.Close();
				return true;
			}
			catch( Exception e )
			{
				Console.WriteLine(e.Message);
				Console.WriteLine(e.StackTrace);
				if(sqlConnection.State == ConnectionState.Open)
					sqlConnection.Close();
				return false;
			}
		}

		public static string DateBg( DateTime dateTime )
		{
			string s = dateTime.Day.ToString();
			s += ".";
			s += dateTime.Month;
			s += ".";
			s += dateTime.Year;
			s += " г.";
			return s;
		}

		public static DateTime ToDate(string date)
		{
			if( date == "")
				return new DateTime(1900,1,1);
			date= date.Trim();
			// Day
			int i = date.IndexOf(".");
			int day = int.Parse(date.Substring(0,i)) ;
			// Month
			date = date.Substring(i+1);
			i = date.IndexOf(".");
			int mounth = int.Parse(date.Substring(0,i));
			//Year
			date = date.Substring(i+1,4);
			int year = int.Parse(date);

			return new DateTime(year,mounth,day);
		}

		
		public virtual Root CreateInstance()
		{
			return new Root();
		}

		/// <summary>
		/// Conctats two hash tables 
		/// </summary>
		/// <param name="hash1">hash2 will be added to hash1</param>
		/// <param name="hash2"></param>
		protected static void ConcatHashtables( Hashtable hash1, Hashtable hash2 )
		{
			foreach( object o in hash2.Keys)
				hash1.Add( o, hash2[o] );
		}
		

	}
}
