using System;
using System.Collections;
using System.Text;
using System.Data;
using RecognizeSignature.DataBase;

namespace RecognizeSignature 
{
	/// <summary>
	/// Summary description for SignRecognize.
	/// </summary>
	public class SignRecognize
	{
		public SignRecognize()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static double EvklidDistance(ArrayList recognizeData,ArrayList databaseDataN)
		{
			double result = 0;

			for( int i =0; i < databaseDataN.Count; i++)
			{
				result += Math.Pow( ( double.Parse(recognizeData[i].ToString())- double.Parse(databaseDataN[i].ToString()) ),2);
			}
			return Math.Pow( result, 0.5);

		}

		public static ArrayList GetSignPropertie(Signature sg)
		{
			ArrayList signProp = new ArrayList();
			
			signProp.Add(sg.Distance);
			signProp.Add(sg.Angle*100);
			signProp.Add(sg.DispersiaX);
            signProp.Add(sg.DispersiaY);
            signProp.Add(sg.DispersiaP);
            signProp.Add(sg.NumberStrokes*1000);
            signProp.Add(sg.NumberPixels);
            signProp.Add(sg.Width);
            signProp.Add(sg.Length);
            signProp.Add(sg.Complexity*1000);
			
			return signProp;
		}

		public static RecognizeSignature.DataBase.Person RecognizeSignaturePerson_Evklid(Signature signTablet)
		{
			
			Signature signDB = new Signature();
			string cosntraint = "Kind = 1";
			object [] signs = signDB.Find(cosntraint);

			ArrayList recognizeData = GetSignPropertie(signTablet);
			ArrayList signPerson = new ArrayList();
			double minDistance = 100000000000;
			int idPerson = 0;

			for(int i=0; i < signs.Length; i++)
			{
				signPerson = GetSignPropertie( (Signature)signs[i]);
				double evklidDistance = EvklidDistance(recognizeData,signPerson);
				if( minDistance > evklidDistance)
				{
					minDistance = evklidDistance;
					idPerson = ((Signature)signs[i]).IdPerson;
				}

			}

			Person pr = new Person();
			cosntraint = "Id = " + idPerson;
			object [] person = pr.Find(cosntraint);
			if( person.Length > 0)
				pr = (Person)person[0];
			
			return pr;
		}
	}
}
